#ifndef HOSTTMR_H_
#define HOSTTMR_H_

#ifdef __cplusplus
extern "C" {
#endif

//////////////////////////////////////////////////////////////////////////
// Timer

//Starts the timer services.
void HostTmr_Start();

//Stops the timer services.
void HostTmr_Stop();

//Standard millisecond timer -- sets *value to the number of milliseconds
//elapsed since whenever.
void HostTmr_ReadMilliseconds(int *value);

//High frequency timer -- read current reading, or query its frequency.
//(This needs to be accurate to at least a millisecond or so, which the
//Windows millisecond timers aren't.)

typedef LONGLONG HostTmr_HfValue;

void HostTmr_ReadHf(HostTmr_HfValue *value);

int HostTmr_GetHfFrequency(HostTmr_HfValue *frequency);

#ifdef __cplusplus
}
#endif

#endif
