#ifndef bbcADC_H_
#define bbcADC_H_

#include "bbcDebugPanel.h"

class bbcAdc {
public:
	static void Init();
	static void Reset();

	static void Update(int cycles);

	static t65::byte Read(t65::word addr);
	static void Write(t65::word addr,t65::byte val);

	static void SetJoystick(int joystick,float x,float y);
	static void SetChannelValue(int channel,float value);

#ifdef bbcDEBUG_PANELS
	static void InitDebugPanel(bbcDebugPanel *panel);
	static void UpdateDebugPanel(bbcDebugPanel *panel);
#endif
protected:
private:
	static int next_stop_at_;
	static bool busy_;
	static bool is_8bit_;
	static int input_channel_;
	static float channels_[4];
	static t65::Word last_conversion_;
	static bool conversion_complete_;
};

inline void bbcAdc::SetChannelValue(int channel,float value) {
	BASSERT(channel>=0&&channel<4);
	channels_[channel]=value;
}

//bbc joysticks are the wrong way round compared to PC ones...
inline void bbcAdc::SetJoystick(int joystick,float x,float y) {
	BASSERT(joystick==0||joystick==1);
	
	channels_[joystick*2+0]=.5f-x*.5f;
	channels_[joystick*2+1]=.5f-y*.5f;
}

#endif