#ifndef bbcROMSLOT_H_
#define bbcROMSLOT_H_

#include "bbcCommon.h"
#include <algorithm>

struct bbcRomSlot {
	bbcRomSlot();
	void GetPages(t65::byte **read_pages,t65::byte **write_pages) const;
	void GetReadPages(t65::byte **read_pages) const;
	void GetWritePages(t65::byte **write_pages) const;
	void ResetContents();
	void SetContents(const t65::byte *src,unsigned num_bytes);
	void SetWriteable(bool is_writeable);
	void WriteByte(t65::word offset,t65::byte val);
private:
	void ResetPages();
	t65::byte *read_pages_[64];
	t65::byte *write_pages_[64];
	bool is_writeable_;
	t65::byte contents_[16384];
	static t65::byte dummy_page[256];//where writes to non-writeable ROMs go.
};

inline void bbcRomSlot::GetReadPages(t65::byte **read_pages) const {
	memcpy(read_pages,read_pages_,64*sizeof(t65::byte *));
}

inline void bbcRomSlot::GetWritePages(t65::byte **write_pages) const {
	memcpy(write_pages,write_pages_,64*sizeof(t65::byte *));
}

inline void bbcRomSlot::GetPages(t65::byte **read_pages,t65::byte **write_pages) const {
	this->GetReadPages(read_pages);
	this->GetWritePages(write_pages);
}

inline void bbcRomSlot::SetWriteable(bool is_writeable) {
	is_writeable_=is_writeable;
	this->ResetPages();
}

inline void bbcRomSlot::WriteByte(t65::word offset,t65::byte val) {
	BASSERT(offset<16384);
	contents_[offset]=val;
}

#endif
