#ifndef SYSTEMVIA_H_
#define SYSTEMVIA_H_

#include "bbcVIA.h"
#include "bbcKeys.h"

class bbcSystemVIA:
public bbcVIA
{
public:
	bbcSystemVIA();

	static t65::byte MmioRead(t65::word addr);
	static void MmioWrite(t65::word addr,t65::byte val);
	
	bool KeyState(bbcKey key);
	void SetKeyState(bbcKey key,bool state);
	void SetJoystickButtonState(int joystick,bool state);
	void ReadingPa();
    void ReadingPb();
    void WrittenPa();
    void WrittenPb();
	void DoKeyboardIrq();
	
	bool CapslockLedLit();
	bool ShiftlockLedLit();
	
	void SetCmos(t65::byte *cmos);
private:
    //bool latch_[8];           // the addressable latch
	t65::byte latch_;
    static const t65::word wraptbl_[4];         // table for screen wrap sizes
	bool joystick_buttons_[2];
	t65::byte *cmos_;
	bool cmos_op_read_;
	bool cmos_enabled_;
	bool cmos_data_strobe_;
	t65::byte cmos_address_;

//	t65::byte CmosRead(t65::byte address);
//	void CmosWrite(t65::byte address,t65::byte value);

	t65::byte latched_pb_;

	void SlowWrite(t65::byte value);
};

extern bbcSystemVIA bbc_system_via;

#endif
