#include "pch.h"
#include "mbMainFrame.h"
#include "mbMisc.h"
#include "mbApp.h"
#include <crtdbg.h>

#if wxUSE_THREADS
//#error "wxWindows has threads enabled. Please decide what you're going to do!"
#endif

extern const bool tw_track_heap_allocations=true;
extern const int tw_unknown_allocation_break=-1;

//////////////////////////////////////////////////////////////////////////

#ifdef _CONSOLE
static BOOL WINAPI ConsoleCtrlHandler(DWORD dwCtrlType) {
	switch(dwCtrlType) {
	case CTRL_C_EVENT:
	case CTRL_BREAK_EVENT:
	case CTRL_CLOSE_EVENT:
		{
			mbMainFrame *frame=wxGetApp().MainFrame();
			if(frame) {
				frame->Close(true);//true=force close (no veto)
				return TRUE;
			}
		}
		break;
	}
	return FALSE;
}

int main(int argc,char *argv[]) {
#ifdef _CONSOLE
	{
		static const int console_width=128;
		HANDLE handle=GetStdHandle(STD_OUTPUT_HANDLE);
		COORD size;
		size.X=console_width;
		size.Y=2000;
		SetConsoleScreenBufferSize(handle,size);
		SMALL_RECT r;
		r.Left=0;
		r.Top=0;
		r.Right=console_width-1;
		r.Bottom=50;
		SetConsoleWindowInfo(handle,TRUE,&r);

		SetConsoleCtrlHandler(&ConsoleCtrlHandler,TRUE);//TRUE=add
	}
#endif
	wxString args;
	for(int i=1;i<argc;++i) {
		if(!args.empty()) {
			args+=" ";
		}
		args+="\"";
		args+=argv[i];
		args+="\"";
	}
	char *cmdline=strdup(args.c_str());
	int r=WinMain(GetModuleHandle(0),0,cmdline,SW_SHOW);
	free(cmdline);
	return r;
}
#endif
