#ifndef MBHARDWAREDIALOG_H_
#define	MBHARDWAREDIALOG_H_

#include "mbConfig.h"
#include "mbDiscInterface.h"
#include "mbModel.h"

class mbHardwareDialog:
public wxDialog
{
public:
	mbHardwareDialog(wxWindow *parent,const mbMiscConfig &cfg,const mbRomsConfig &roms_cfg);

	void GetResult(mbMiscConfig *cfg,mbRomsConfig *roms_cfg) const;
protected:
private:
	DECLARE_EVENT_TABLE();

	mbMiscConfig cfg_;
	mbRomsConfig roms_cfg_;
	
	struct ModelRom {
		wxTextCtrl *file_name;
		wxButton *select_file;
		mbRomsConfig::Rom *rom;
		int slot;

		ModelRom();
	};

	struct Model {
		const mbModel *model;
		wxString *model_os;
		std::vector<ModelRom> model_roms;
		wxTextCtrl *os_file_name;
		wxButton *select_file;
		wxRadioButton *radio;

		Model();
	};

	std::vector<Model> models_;

	struct Interface {
		const mbDiscInterface *iface;

		wxRadioButton *radio;
		wxTextCtrl *file_name;
		wxButton *select_file;

		Interface();
		void SetEnabled(bool enabled);
	private:
		void Enable(wxControl *w,bool enabled);
	};

	std::vector<Interface> interfaces_;

	wxRadioButton *b_,*bplus_;

	void OnFsel(wxCommandEvent &event);
	void OnInterfaceRadio(wxCommandEvent &event);
	void OnModelRadio(wxCommandEvent &event);
	void OnOk(wxCommandEvent &event);

	void RefreshDialog();
	wxBoxSizer *CreateTextCtrlFsel(const wxString &caption,wxTextCtrl **text,wxButton **button);
	void GetFselDetails(wxObject *src,wxTextCtrl **ctrl,wxString **string,wxString *caption);
};

#endif