#include "pch.h"
#include "mbJoyKeys.h"

//mbJOYKEY_TX_NEG,
//mbJOYKEY_TX_POS,
//mbJOYKEY_TY_NEG,
//mbJOYKEY_TY_POS,
//mbJOYKEY_TZ_NEG,
//mbJOYKEY_TZ_POS,
//mbJOYKEY_RX_NEG,
//mbJOYKEY_RX_POS,
//mbJOYKEY_RY_NEG,
//mbJOYKEY_RY_POS,
//mbJOYKEY_RZ_NEG,
//mbJOYKEY_RZ_POS,
//mbJOYKEY_BUTTON_0,
//mbJOYKEY_BUTTON_LAST=mbJOYKEY_BUTTON_0+HostInp_num_joystick_buttons,

static const wxArrayString &JoyKeyNames() {
	static wxArrayString names;

	if(names.GetCount()==0) {
		names.SetCount(mbJOYKEY_NUM);
		names[mbJOYKEY_TX_NEG]="Translate -X";
		names[mbJOYKEY_TX_POS]="Translate +X";
		names[mbJOYKEY_TY_NEG]="Translate -Y";
		names[mbJOYKEY_TY_POS]="Translate +Y";
		names[mbJOYKEY_TZ_NEG]="Translate -Z";
		names[mbJOYKEY_TZ_POS]="Translate +Z";
		names[mbJOYKEY_RX_NEG]="Rotate -X";
		names[mbJOYKEY_RX_POS]="Rotate +X";
		names[mbJOYKEY_RY_NEG]="Rotate -Y";
		names[mbJOYKEY_RY_POS]="Rotate +Y";
		names[mbJOYKEY_RZ_NEG]="Rotate -Z";
		names[mbJOYKEY_RZ_POS]="Rotate +Z";
		for(unsigned i=0;i<HostInp_num_joystick_buttons;++i) {
			names[mbJOYKEY_BUTTON_0+i]=wxString::Format("button %u",i);
		}
	}

	return names;
}

const wxString &mbJoyKeyNameFromKey(mbJoyKey key) {
	return JoyKeyNames()[key];
}

mbJoyKey mbJoyKeyFromKeyName(const wxString &name) {
	int idx=JoyKeyNames().Index(name,FALSE);
	if(idx==wxNOT_FOUND) {
		return mbJOYKEY_INVALID;
	} else {
		return mbJoyKey(idx);
	}
}

void mbJoyKeyGetIndexAndKey(HostInpState *hostinp,const mbKeymap::Key &key,int *joy_index,
	mbJoyKey *joy_key)
{
	*joy_index=-1;
	*joy_key=mbJoyKeyFromKeyName(key.key);

	for(int index=0;index<HostInp_NumJoysticks(hostinp);++index) {
		if(key.device==HostInp_JoystickName(hostinp,index)) {
			*joy_index=index;
			break;
		}
	}
}

static inline void GetState(float v,mbJoyKey neg,mbJoyKey pos,char *key_states) {
	key_states[neg]=v<-.5f;
	key_states[pos]=v>.5f;
}

void mbJoyKeyGetKeyStates(const HostInp_JoyState *state,mbJoyKeyState *key_states) {
	GetState(state->x,mbJOYKEY_TX_NEG,mbJOYKEY_TX_POS,key_states->states);
	GetState(state->y,mbJOYKEY_TY_NEG,mbJOYKEY_TY_POS,key_states->states);
	GetState(state->z,mbJOYKEY_TZ_NEG,mbJOYKEY_TZ_POS,key_states->states);
	GetState(state->rx,mbJOYKEY_RX_NEG,mbJOYKEY_RX_POS,key_states->states);
	GetState(state->ry,mbJOYKEY_RY_NEG,mbJOYKEY_RY_POS,key_states->states);
	GetState(state->rz,mbJOYKEY_RZ_NEG,mbJOYKEY_RZ_POS,key_states->states);
	for(unsigned i=0;i<HostInp_num_joystick_buttons;++i) {
		key_states->states[mbJOYKEY_BUTTON_0+i]=!!state->buttons[i];
	}
}
