#ifndef mbMODEL_H_
#define mbMODEL_H_

#include <bbcModel.h>
#include "mbConfig.h"

struct mbModelRomsLoader;

struct mbModel {
	const char *const long_name;
	const char *const short_name;
	const bbcModel *const model;
	t65::word b_rom_mask;
	t65::word force_swram_mask;
	wxString mbRomsConfig::*const os_name;
	const char *const *const valid_disc_interfaces;

	mbModel(const char *long_name,const char *short_name,const bbcModel *model,t65::word b_rom_mask,
		const unsigned *filenames_offsets,wxString mbRomsConfig::*os_name,t65::word force_swram_mask,const char **valid_disc_interfaces);

	//returns ptr to mbRomsConfig::Rom representing given slot for this model in the cfg.
	mbRomsConfig::Rom *CfgRomPtr(mbRomsConfig &cfg,int slot) const;
	const mbRomsConfig::Rom *CfgRomPtr(const mbRomsConfig &cfg,int slot) const;

	//mbRomsConfig::Rom mbRomsConfig::*GetRomsPtrs(mbRomsConfig &cfg);

	bool LoadRoms(const mbRomsConfig &cfg) const;
	
private:
	const unsigned *filenames_offsets_;
	bool LoadRom(int slot,const mbRomsConfig::Rom *rom) const;
};

const mbModel *mbModelFromShortName(const wxString &short_name);
void mbModelGetAll(std::vector<const mbModel *> *all_models);

#endif
