#ifndef mbROMSCONFIGDIALOG_H_
#define mbROMSCONFIGDIALOG_H_

#include "mbConfig.h"
#include "mbModel.h"

class wxGenericValidator;

class mbRomsConfigDialog:
public wxDialog
{
public:
	mbRomsConfigDialog(wxWindow *parent,wxWindowID id,mbRomsConfig &cfg,const mbModel *model);
	~mbRomsConfigDialog();

	void GetResult(mbRomsConfig *cfg) const;
protected:
private:
	DECLARE_EVENT_TABLE();
	
//	mbRomsConfig::Rom roms_[16];
	mbRomsConfig cfg_;

	struct RomControls {
		int slot;
		wxBoxSizer *sizer;
		wxStaticText *slot_number;
		wxTextCtrl *file_name;
		wxButton *select_file;
		wxCheckBox *is_ram;

		wxTextValidator *file_name_vd;
		wxGenericValidator *is_ram_vd;

		RomControls();
#ifdef __WXDEBUG__
		bool AllOk() const;
#endif
	};

	//Controls
	RomControls *rom_controls_[16];
	wxRadioButton *rom_is_fs_[16];
	int result_flags_;
	const mbModel *model_;

	void ResetRomControls();
	void RefreshRomControls();
	void RefreshDialog();

	//cmds
	void OnFileSelect(wxCommandEvent &event);
	void OnOk(wxCommandEvent &event);
	void OnCancel(wxCommandEvent &event);
	void OnApplyReset(wxCommandEvent &event);
	void OnIsFs(wxCommandEvent &event);
	void DataOk(int flags);
};

#endif
